---
categories: web
title: Howto Puma
...

[Puma](http://puma.io/) est un serveur d'application Ruby on rails.

## 0. Prérequis

Installation de Puma :

~~~
gem install puma
~~~

Création du dossier de configuration :

~~~
mkdir -m 0750 /etc/puma
~~~

Création d'un service SystemD :

~~~
cat > /etc/systemd/user/puma.service <<EOF
[Unit]
Description=Puma HTTP server for Ruby Apps : %u
After=network.target

[Service]
WorkingDirectory=%h/www
UMask=0027
PIDFile=%h/ruby.pid
ExecStartPre=/bin/mkdir -m 0750 %h/run
ExecStart=/usr/local/bin/puma --bind unix://%h/run/puma.sock?umask=0007 --pidfile %h/run/puma.pid --dir %h/www --config /etc/puma/%u.rb
ExecReload=/bin/kill -USR2 $MAINPID
KillMode=process
#Restart=on-failure

[Install]
WantedBy=multi-user.target
Alias=puma.service
EOF
~~~

Correction des droits du service SystemD

~~~
chmod 644 /etc/systemd/system/puma@.service
~~~

## 1. Configuration

Création du fichier de configuration de Puma pour l'utilisateur $USER :

~~~
cat > /etc/puma/$USER.rb <<EOF
environment 'production'
workers 2
threads 0, 4
tag 'Puma $USER'
EOF
~~~

Correction des droits du fichier de configuration

~~~
chmod -m 0640 /etc/puma/$USER.rb
chown $USER: /etc/puma/$USER.rb
~~~